"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.AddButtonTrigger = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _q3UiLocale = require("q3-ui-locale");
var _q3UiDialog = _interopRequireDefault(require("q3-ui-dialog"));
var _Box = _interopRequireDefault(require("@material-ui/core/Box"));
var _Button = _interopRequireDefault(require("@material-ui/core/Button"));
var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));
var _Hidden = _interopRequireDefault(require("@material-ui/core/Hidden"));
var _Add = _interopRequireDefault(require("@material-ui/icons/Add"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const ForwardProps = ({
  children,
  ...rest
}) => /*#__PURE__*/_react.default.cloneElement(children, rest);
const AddButtonTableRow = props => /*#__PURE__*/_react.default.createElement(_Box.default, null, /*#__PURE__*/_react.default.createElement(_q3UiDialog.default, props));
const AddButtonTrigger = ({
  onClick
}) => {
  const {
    t
  } = (0, _q3UiLocale.useTranslation)();
  return /*#__PURE__*/_react.default.createElement(_Box.default, {
    id: "q3-repeater-add-button"
  }, /*#__PURE__*/_react.default.createElement(_Hidden.default, {
    smDown: true
  }, /*#__PURE__*/_react.default.createElement(_Box.default, {
    ml: 1
  }, /*#__PURE__*/_react.default.createElement(_Button.default, {
    color: "secondary",
    onClick: onClick,
    variant: "contained"
  }, t('labels:addNew')))), /*#__PURE__*/_react.default.createElement(_Hidden.default, {
    mdUp: true
  }, /*#__PURE__*/_react.default.createElement(_IconButton.default, {
    color: "inherit",
    onClick: onClick,
    label: t('labels:addNew')
  }, /*#__PURE__*/_react.default.createElement(_Add.default, null))));
};
exports.AddButtonTrigger = AddButtonTrigger;
AddButtonTrigger.propTypes = {
  /**
   * Click handler for custom button.
   */
  onClick: _propTypes.default.func.isRequired
};
const AddButton = ({
  name,
  collectionName,
  initialValues,
  create,
  children
}) => /*#__PURE__*/_react.default.createElement(AddButtonTableRow, {
  variant: "drawer",
  title: `${name}Create`,
  renderTrigger: open => /*#__PURE__*/_react.default.createElement(AddButtonTrigger, {
    onClick: open
  }),
  renderContent: close => /*#__PURE__*/_react.default.createElement(ForwardProps, {
    onSubmit: (...args) => create(...args).then(() => {
      close();
    }),
    collectionName: collectionName,
    initialValues: initialValues,
    isNew: true
  }, children)
});
AddButton.defaultProps = {
  name: ''
};
AddButton.propTypes = {
  /**
   * Used to create a unique Dialog title.
   */
  name: _propTypes.default.string,
  /**
   * Used to determine permission level
   */
  collectionName: _propTypes.default.string.isRequired,
  /**
   * Empty state for new resource
   */
  initialValues: _propTypes.default.shape({}).isRequired,
  /**
   * On submit handler
   */
  create: _propTypes.default.func.isRequired,
  /**
   * Used to clone editor into an "Add" form.
   */
  children: _propTypes.default.node.isRequired
};
var _default = AddButton;
exports.default = _default;