"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Auth = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _lodash = require("lodash");
var _q3UiPermissions = require("q3-ui-permissions");
var _state = _interopRequireDefault(require("../state"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const getAuthByMethodName = op => {
  switch (op) {
    case 'Create':
      return 'canCreateSub';
    case 'Update':
      return 'canEditSub';
    case 'Delete':
      return 'canDeleteSub';
    case 'Read':
    default:
      return 'canSeeSub';
  }
};
const Auth = ({
  children,
  op
}) => {
  const {
    name,
    collectionName
  } = _react.default.useContext(_state.default);
  const can = (0, _lodash.invoke)((0, _q3UiPermissions.useAuth)(collectionName), getAuthByMethodName(op), name);
  if (!children || !can && collectionName) return null;
  return /*#__PURE__*/_react.default.cloneElement(children, {
    name,
    collectionName
  });
};
exports.Auth = Auth;
Auth.propTypes = {
  children: _propTypes.default.node,
  op: _propTypes.default.string.isRequired
};
Auth.defaultProps = {
  children: null
};
var _default = Auth;
exports.default = _default;