"use strict";

var _react = _interopRequireDefault(require("react"));
var _q3UiPermissions = require("q3-ui-permissions");
var _Auth = _interopRequireDefault(require("./Auth"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
jest.mock('q3-ui-permissions', () => ({
  useAuth: jest.fn()
}));
beforeAll(() => {
  jest.spyOn(_react.default, 'useContext').mockReturnValue({
    collectionName: 'Foo',
    name: 'Bar'
  });
});
describe('"Auth"', () => {
  it('should return null without children', () => {
    const el = global.shallow( /*#__PURE__*/_react.default.createElement(_Auth.default, {
      op: "Read"
    }));
    expect(el).toEqual({});
  });
  it('should return null without permissions', () => {
    _q3UiPermissions.useAuth.mockReturnValue({
      canSeeSub: jest.fn().mockReturnValue(false)
    });
    const el = global.shallow( /*#__PURE__*/_react.default.createElement(_Auth.default, {
      op: "Read"
    }, /*#__PURE__*/_react.default.createElement("div", null)));
    expect(el).toEqual({});
  });
  it('should forward props to children', () => {
    const clone = jest.spyOn(_react.default, 'cloneElement');
    _q3UiPermissions.useAuth.mockReturnValue({
      canSeeSub: jest.fn().mockReturnValue(true)
    });
    global.shallow( /*#__PURE__*/_react.default.createElement(_Auth.default, {
      op: "Read"
    }, /*#__PURE__*/_react.default.createElement("div", null)));
    expect(clone).toHaveBeenCalledWith(expect.any(Object), expect.objectContaining({
      collectionName: expect.any(String),
      name: expect.any(String)
    }));
  });
});