"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _lodash = require("lodash");
var _q3UiConfirm = _interopRequireDefault(require("q3-ui-confirm"));
var _DeleteSweep = _interopRequireDefault(require("@material-ui/icons/DeleteSweep"));
var _core = require("@material-ui/core");
var _q3UiExports = require("q3-ui-exports");
var _q3UiLocale = require("q3-ui-locale");
var _state = _interopRequireDefault(require("../state"));
var _Auth = _interopRequireDefault(require("../Auth"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const BulkDeleteModal = () => {
  const {
    t
  } = (0, _q3UiLocale.useTranslation)('labels');
  const {
    checked
  } = _react.default.useContext(_q3UiExports.State);
  const {
    disableRemove,
    removeBulk
  } = _react.default.useContext(_state.default);
  const ButtonComponent = _react.default.useCallback(props => /*#__PURE__*/_react.default.createElement(_core.Tooltip, {
    arrow: true,
    title: t('bulkDelete')
  }, /*#__PURE__*/_react.default.createElement("span", null, /*#__PURE__*/_react.default.createElement(_core.IconButton, _extends({}, props, {
    color: "inherit",
    className: "q3-repeater-bulk-delete"
    // eslint-disable-next-line
    ,
    disabled: !checked.length || props.disabled
  }), /*#__PURE__*/_react.default.createElement(_DeleteSweep.default, null)))), [checked]);
  return (0, _lodash.isFunction)(removeBulk) && !disableRemove ? /*#__PURE__*/_react.default.createElement(_Auth.default, {
    op: "Delete"
  }, /*#__PURE__*/_react.default.createElement(_q3UiConfirm.default, {
    ButtonComponent: ButtonComponent,
    description: "confirmDeleteMany",
    icon: _DeleteSweep.default,
    service: removeBulk(checked),
    title: "confirmDeleteMany",
    label: "delete"
  })) : null;
};
BulkDeleteModal.defaultProps = {
  ids: []
};
BulkDeleteModal.propTypes = {
  ids: _propTypes.default.arrayOf(_propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]))
};
var _default = /*#__PURE__*/_react.default.memo(BulkDeleteModal);
exports.default = _default;