"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _q3UiDialog = _interopRequireDefault(require("q3-ui-dialog"));
var _lodash = require("lodash");
var _q3UiExports = require("q3-ui-exports");
var _core = require("@material-ui/core");
var _Edit = _interopRequireDefault(require("@material-ui/icons/Edit"));
var _q3UiLocale = require("q3-ui-locale");
var _Auth = _interopRequireDefault(require("../Auth"));
var _state = _interopRequireDefault(require("../state"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const BulkEditorDrawer = ({
  children
}) => {
  const {
    t
  } = (0, _q3UiLocale.useTranslation)('labels');
  const {
    checked
  } = _react.default.useContext(_q3UiExports.State);
  const {
    disableEditor,
    editBulk
  } = _react.default.useContext(_state.default);
  return (0, _lodash.isFunction)(editBulk) && !disableEditor ? /*#__PURE__*/_react.default.createElement(_Auth.default, {
    op: "Update"
  }, /*#__PURE__*/_react.default.createElement(_q3UiDialog.default, {
    title: "editMany",
    renderContent: close => {
      const args = {
        onSubmit: editBulk(checked, close)
      };
      return typeof children === 'function' ? children(args) : /*#__PURE__*/_react.default.cloneElement(children, args);
    },
    renderTrigger: onClick => /*#__PURE__*/_react.default.createElement(_core.Tooltip, {
      arrow: true,
      title: t('bulkUpdate')
    }, /*#__PURE__*/_react.default.createElement("span", null, /*#__PURE__*/_react.default.createElement(_core.IconButton, {
      color: "inherit",
      className: "q3-repeater-bulk-update",
      disabled: !checked.length,
      onClick: onClick
    }, /*#__PURE__*/_react.default.createElement(_Edit.default, null))))
  })) : null;
};
BulkEditorDrawer.propTypes = {
  children: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.object]).isRequired
};
var _default = BulkEditorDrawer;
exports.default = _default;