"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _lodash = require("lodash");
var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));
var _KeyboardArrowDown = _interopRequireDefault(require("@material-ui/icons/KeyboardArrowDown"));
var _KeyboardArrowUp = _interopRequireDefault(require("@material-ui/icons/KeyboardArrowUp"));
var _TableCell = _interopRequireDefault(require("@material-ui/core/TableCell"));
var _classnames = _interopRequireDefault(require("classnames"));
var _ItemActionsWrapper = _interopRequireDefault(require("../ItemActionsWrapper"));
var _DeleteModal = _interopRequireDefault(require("../DeleteModal"));
var _useStyle = _interopRequireDefault(require("../useStyle"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const ItemActions = ({
  actions,
  children,
  showEditor,
  showRemove,
  toggleNested,
  nestedIsVisible,
  renderNestedTableRow,
  id
}) => {
  const {
    tableCell,
    tableActions
  } = (0, _useStyle.default)();
  return /*#__PURE__*/_react.default.createElement(_TableCell.default, {
    className: (0, _classnames.default)(tableCell, tableActions)
  }, renderNestedTableRow && /*#__PURE__*/_react.default.createElement(_IconButton.default, {
    "aria-label": "toggle-info",
    onClick: toggleNested
  }, nestedIsVisible ? /*#__PURE__*/_react.default.createElement(_KeyboardArrowUp.default, null) : /*#__PURE__*/_react.default.createElement(_KeyboardArrowDown.default, null)), showEditor && /*#__PURE__*/_react.default.createElement(_ItemActionsWrapper.default, {
    id: id
  }, children), (0, _lodash.map)(actions, ({
    component: Component,
    label,
    ...rest
  }, idx) => /*#__PURE__*/_react.default.createElement(_ItemActionsWrapper.default, _extends({}, rest, {
    id: id,
    key: label || idx,
    label: label
  }), /*#__PURE__*/_react.default.createElement(Component, null))), showRemove && /*#__PURE__*/_react.default.createElement(_DeleteModal.default, {
    id: id
  }));
};
ItemActions.propTypes = {
  actions: _propTypes.default.arrayOf(_propTypes.default.shape({
    label: _propTypes.default.string,
    icon: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.node]),
    component: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.node])
  })),
  id: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]).isRequired,
  children: _propTypes.default.node.isRequired,
  toggleNested: _propTypes.default.func.isRequired,
  showEditor: _propTypes.default.bool,
  showRemove: _propTypes.default.bool,
  nestedIsVisible: _propTypes.default.bool,
  renderNestedTableRow: _propTypes.default.func
};
ItemActions.defaultProps = {
  actions: [],
  showRemove: true,
  showEditor: true,
  nestedIsVisible: false,
  renderNestedTableRow: null
};
var _default = ItemActions;
exports.default = _default;