"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _core = require("@material-ui/core");
var _q3UiDialog = _interopRequireDefault(require("q3-ui-dialog"));
var _lodash = require("lodash");
var _q3UiLocale = require("q3-ui-locale");
var _Edit = _interopRequireDefault(require("@material-ui/icons/Edit"));
var _state = _interopRequireWildcard(require("../state"));
var _useNextPrev = _interopRequireDefault(require("../useNextPrev"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const ItemActionsWrapper = ({
  children,
  disableDialog,
  icon: Icon,
  label,
  id
}) => {
  const ref = _react.default.useRef();
  const {
    state,
    setState
  } = _react.default.useContext(_state.ActionContext);
  const {
    collectionName,
    edit
  } = _react.default.useContext(_state.default);
  const {
    t
  } = (0, _q3UiLocale.useTranslation)('labels');
  const {
    data,
    next,
    prev
  } = (0, _useNextPrev.default)(state);
  const {
    data: row
  } = (0, _useNextPrev.default)(id);
  const renderChildren = (args = {}) => children && (!(0, _lodash.isNil)(data) || disableDialog) ? /*#__PURE__*/_react.default.cloneElement(children, {
    ...args,
    onSubmit: edit(state || id),
    initialValues: data || {},
    collectionName,
    row,
    id
  }) : null;
  const renderContent = (close, isOpen) => isOpen && renderChildren({
    close
  });
  const renderTrigger = toggle => /*#__PURE__*/_react.default.createElement(_core.Tooltip, {
    arrow: true,
    title: t(label)
  }, /*#__PURE__*/_react.default.createElement(_core.IconButton, {
    ref: ref,
    "aria-label": label,
    className: "q3-repeater-editor-button",
    color: "inherit",
    onClick: toggle
  }, /*#__PURE__*/_react.default.createElement(Icon, null)));

  // React.useEffect(() => {
  //   try {
  //     ref.current
  //       .closest('tr')
  //       .setAttribute('data-active-id', state);
  //   } catch (e) {
  //     // noop
  //   }
  // }, [state]);

  const DialogRenderer = _react.default.useMemo(() => /*#__PURE__*/_react.default.createElement(_q3UiDialog.default, {
    ModalProps: {
      disablePortal: true
    },
    SlideProps: {
      onEnter: () => setState(id),
      onExited: () => setState(null)
    },
    key: label,
    onNext: () => setState(next()),
    onPrev: () => setState(prev()),
    renderContent: renderContent,
    renderTrigger: renderTrigger,
    title: label,
    variant: "drawer"
  }), [id, data]);
  return disableDialog ? renderChildren() : DialogRenderer;
};
ItemActionsWrapper.propTypes = {
  children: _propTypes.default.node.isRequired,
  disableDialog: _propTypes.default.bool,
  icon: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.node, _propTypes.default.object]),
  id: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]).isRequired,
  label: _propTypes.default.string
};
ItemActionsWrapper.defaultProps = {
  disableDialog: false,
  icon: _Edit.default,
  label: 'editor'
};
var _default = ItemActionsWrapper;
exports.default = _default;