"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));
var _Avatar = _interopRequireDefault(require("@material-ui/core/Avatar"));
var _Grid = _interopRequireDefault(require("@material-ui/core/Grid"));
var _Box = _interopRequireDefault(require("@material-ui/core/Box"));
var _Hidden = _interopRequireDefault(require("@material-ui/core/Hidden"));
var _TableCell = _interopRequireDefault(require("@material-ui/core/TableCell"));
var _q3UiExports = require("q3-ui-exports");
var _useStyle = _interopRequireDefault(require("../useStyle"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const ItemHeader = ({
  showMultiselect,
  item,
  description,
  icon,
  photo,
  title
}) => {
  const {
    id
  } = item;
  const multiselect = _react.default.useContext(_q3UiExports.State);
  const selected = multiselect.isChecked(id);
  const {
    titleCls,
    tableCellHeader
  } = (0, _useStyle.default)({
    selected
  });
  return /*#__PURE__*/_react.default.createElement(_TableCell.default, {
    className: tableCellHeader
  }, /*#__PURE__*/_react.default.createElement(_Grid.default, {
    alignItems: "center",
    container: true,
    spacing: 1
  }, showMultiselect && /*#__PURE__*/_react.default.createElement(_Hidden.default, {
    implementation: "css",
    smDown: true
  }, /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true
  }, /*#__PURE__*/_react.default.createElement(_q3UiExports.SelectOne, {
    id: id
  }))), icon && /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true
  }, icon(item)), photo && /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true
  }, /*#__PURE__*/_react.default.createElement(_Avatar.default, {
    src: photo,
    alt: title
  })), /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true,
    xs: true,
    zeroMinWidth: true
  }, /*#__PURE__*/_react.default.createElement(_Box.default, {
    component: "h4",
    className: titleCls
  }, title), description && /*#__PURE__*/_react.default.createElement(_Typography.default, {
    style: {
      fontSize: '0.833rem'
    }
  }, description))));
};
ItemHeader.propTypes = {
  title: _propTypes.default.string.isRequired,
  description: _propTypes.default.string,
  item: _propTypes.default.shape({
    id: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]).isRequired
  }).isRequired,
  showMultiselect: _propTypes.default.bool,
  icon: _propTypes.default.func,
  photo: _propTypes.default.string
};
ItemHeader.defaultProps = {
  description: null,
  showMultiselect: true,
  icon: null,
  photo: null
};
var _default = ItemHeader;
exports.default = _default;