"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _TableBody = _interopRequireDefault(require("@material-ui/core/TableBody"));
var _useMediaQuery = _interopRequireDefault(require("@material-ui/core/useMediaQuery"));
var _NestedItem = _interopRequireDefault(require("../NestedItem"));
var _RepeaterTableContext = _interopRequireDefault(require("../RepeaterTableContext"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const List = ({
  children,
  createRenderer,
  renderNestedTableRow,
  ...rest
}) => {
  const {
    data
  } = _react.default.useContext(_RepeaterTableContext.default);
  const showAttributes = (0, _useMediaQuery.default)(theme => theme.breakpoints.up('md'));
  return /*#__PURE__*/_react.default.createElement(_TableBody.default, null, data.map((item, i) => /*#__PURE__*/_react.default.createElement(_NestedItem.default, _extends({
    key: `nestedItem${(i === null || i === void 0 ? void 0 : i.id) || i}`,
    renderNestedTableRow: renderNestedTableRow,
    showAttributes: showAttributes,
    item: item,
    index: i
  }, rest), children)));
};
List.propTypes = {
  children: _propTypes.default.node.isRequired,
  renderNestedTableRow: _propTypes.default.func,
  createRenderer: _propTypes.default.node
};
List.defaultProps = {
  createRenderer: null,
  renderNestedTableRow: null
};
var _default = /*#__PURE__*/_react.default.memo(List);
exports.default = _default;