"use strict";

var _react = _interopRequireDefault(require("react"));
var _TableRow = _interopRequireDefault(require("@material-ui/core/TableRow"));
var _usefulState = require("useful-state");
var _NestedItem = _interopRequireDefault(require("./NestedItem"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
jest.mock('useful-state', () => ({
  useToggle: jest.fn().mockReturnValue([true, jest.fn()])
}));
beforeEach(() => {
  _usefulState.useToggle.mockClear();
});
describe('NestedItem', () => {
  it('should not render nested table', () => {
    expect(global.shallow( /*#__PURE__*/_react.default.createElement(_NestedItem.default, null)).find(_TableRow.default).exists()).toBeFalsy();
  });
  it('should render nested table', () => {
    const fn = jest.fn().mockReturnValue(null);
    expect(global.shallow( /*#__PURE__*/_react.default.createElement(_NestedItem.default, {
      renderNestedTableRow: fn
    })).find(_TableRow.default).exists()).toBeTruthy();
    expect(fn).toHaveBeenCalled();
  });
});