"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _lodash = require("lodash");
var _TableCell = _interopRequireDefault(require("@material-ui/core/TableCell"));
var _TableRow = _interopRequireDefault(require("@material-ui/core/TableRow"));
var _usefulState = require("useful-state");
var _useStyle = _interopRequireDefault(require("../useStyle"));
var _Item = _interopRequireDefault(require("../Item"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const NestedItem = ({
  children,
  item,
  renderNestedTableRow,
  ...rest
}) => {
  const {
    state,
    toggle
  } = (0, _usefulState.useToggle)(true);
  const {
    tableRow
  } = (0, _useStyle.default)();
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Item.default, _extends({
    hasNested: Boolean(renderNestedTableRow),
    toggleNested: toggle,
    nestedIsVisible: !state,
    renderNestedTableRow: renderNestedTableRow,
    item: item
  }, rest), children), renderNestedTableRow && /*#__PURE__*/_react.default.createElement(_TableRow.default, {
    className: tableRow
  }, /*#__PURE__*/_react.default.createElement(_TableCell.default, {
    colSpan: "100%"
  }, !state ? renderNestedTableRow(item, rest) : null)));
};
NestedItem.propTypes = {
  children: _propTypes.default.node.isRequired,
  item: _propTypes.default.shape({
    item: _propTypes.default.string
  }).isRequired,
  renderNestedTableRow: _propTypes.default.func
};
NestedItem.defaultProps = {
  renderNestedTableRow: null
};
var _default = /*#__PURE__*/_react.default.memo(NestedItem, (prev, curr) => (0, _lodash.isEqual)(prev === null || prev === void 0 ? void 0 : prev.item, curr === null || curr === void 0 ? void 0 : curr.item));
exports.default = _default;