"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _q3UiExports = _interopRequireDefault(require("q3-ui-exports"));
var _Repeater = _interopRequireDefault(require("../Repeater"));
var _state = _interopRequireWildcard(require("../state"));
var _useProviderAuth = _interopRequireDefault(require("../useProviderAuth"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const Provider = ({
  disableAdd,
  disableEditor,
  disableRemove,
  create,
  edit,
  editBulk,
  poll,
  remove,
  removeBulk,
  ...rest
}) => {
  const auth = (0, _useProviderAuth.default)(rest);
  const [state, setState] = _react.default.useState();
  const serviceEnablementProps = {
    disableAdd,
    disableEditor,
    disableRemove
  };
  const contextProps = _react.default.useMemo(() => ({
    ...auth,
    ...serviceEnablementProps,
    name: rest.name,
    edit,
    editBulk,
    remove,
    removeBulk,
    poll,
    create
  }), [auth, serviceEnablementProps]);
  const actionProps = _react.default.useMemo(() => ({
    state,
    setState
  }), [state]);
  return !auth.disable ? /*#__PURE__*/_react.default.createElement(_state.ActionContext.Provider, {
    value: actionProps
  }, /*#__PURE__*/_react.default.createElement(_state.default.Provider, {
    value: contextProps
  }, /*#__PURE__*/_react.default.createElement(_q3UiExports.default, null, /*#__PURE__*/_react.default.createElement(_Repeater.default, rest)))) : null;
};
Provider.defaultProps = {
  edit: null,
  collectionName: null,
  create: null,
  remove: null,
  editBulk: null,
  removeBulk: null,
  poll: null,
  name: null,
  disableAdd: false,
  disableEditor: false,
  disableRemove: false
};
Provider.propTypes = {
  edit: _propTypes.default.func,
  name: _propTypes.default.string,
  collectionName: _propTypes.default.string,
  create: _propTypes.default.func,
  remove: _propTypes.default.func,
  editBulk: _propTypes.default.func,
  removeBulk: _propTypes.default.func,
  poll: _propTypes.default.func,
  disableAdd: _propTypes.default.bool,
  disableEditor: _propTypes.default.bool,
  disableRemove: _propTypes.default.bool
};
var _default = Provider;
exports.default = _default;