"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _q3UiAssets = _interopRequireDefault(require("q3-ui-assets"));
var _core = require("@material-ui/core");
var _fp = require("lodash/fp");
var _lodash = require("lodash");
var _ActionBar = _interopRequireDefault(require("../ActionBar"));
var _AddItem = _interopRequireDefault(require("../AddItem"));
var _RepeaterTable = _interopRequireDefault(require("../RepeaterTable"));
var _RepeaterOptions = _interopRequireDefault(require("../RepeaterOptions"));
var _helpers = require("../../helpers");
var _styles = _interopRequireDefault(require("./styles"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const optionType = _propTypes.default.arrayOf(_propTypes.default.shape({
  label: _propTypes.default.string.isRequired,
  fn: _propTypes.default.func
}));
const init = {
  sortBy: 0,
  filterBy: 0,
  input: ''
};
const Repeater = ({
  addComponent,
  bulkEditorComponent,
  emptyComponent,
  children,
  data,
  disableSearch,
  filterOptions,
  groupBy,
  initialValues,
  sortOptions,
  renderOther,
  ...rest
}) => {
  const [state, dispatch] = _react.default.useReducer(_helpers.reducer, init);
  const cls = (0, _styles.default)();
  const run = (0, _fp.compose)((0, _helpers.group)(groupBy), (0, _helpers.sort)(sortOptions[state.sortBy]), (0, _helpers.filter)(filterOptions[state.filterBy]), (0, _helpers.search)(state.input));
  const len = (0, _lodash.size)(data);
  const newData = run(data);
  const showSearch = !disableSearch && len;
  const Add = _react.default.useMemo(() => /*#__PURE__*/_react.default.createElement(_AddItem.default, {
    addComponent: addComponent,
    initialValues: initialValues
  }, children), [initialValues]);
  const CustomElements = _react.default.useMemo(() => (0, _lodash.isFunction)(renderOther) ? renderOther(newData) : null, [newData]);
  const Empty = _react.default.useMemo(() => emptyComponent || /*#__PURE__*/_react.default.createElement(_core.Box, null, /*#__PURE__*/_react.default.createElement(_q3UiAssets.default, {
    icon: "Empty",
    title: "empty"
  })), []);
  const Tools = _react.default.useMemo(() => /*#__PURE__*/_react.default.createElement(_core.Grid, {
    container: true,
    alignItems: "center",
    justifyContent: "space-between",
    direction: addComponent ? 'row' : 'row-reverse'
  }, /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true,
    xs: addComponent ? 12 : undefined
  }, Add), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true
  }, /*#__PURE__*/_react.default.createElement(_RepeaterOptions.default, {
    state: state,
    dispatch: dispatch,
    filterOptions: filterOptions,
    sortOptions: sortOptions,
    disableSearch: !showSearch
  }, /*#__PURE__*/_react.default.createElement(_ActionBar.default, {
    renderSelected: bulkEditorComponent,
    length: len
  }), CustomElements))), [Add, CustomElements, state, filterOptions, sortOptions, showSearch]);
  return /*#__PURE__*/_react.default.createElement(_core.Box, {
    className: cls.root
  }, Tools, /*#__PURE__*/_react.default.createElement(_core.Box, {
    my: 1,
    className: "q3-repeater-tables"
  }, /*#__PURE__*/_react.default.createElement(_RepeaterTable.default, _extends({
    data: newData,
    initialValues: initialValues
  }, rest), children)), /*#__PURE__*/_react.default.createElement(_core.Box, {
    className: "q3-repeater-empty-graphic"
  }, Empty));
};
Repeater.defaultProps = {
  addComponent: null,
  bulkEditorComponent: null,
  data: [],
  disableSearch: false,
  groupBy: null,
  sortOptions: [],
  filterOptions: [],
  emptyComponent: null,
  renderOther: null
};
Repeater.propTypes = {
  addComponent: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.element, _propTypes.default.func]),
  bulkEditorComponent: _propTypes.default.node,
  emptyComponent: _propTypes.default.node,
  initialValues: _propTypes.default.shape({}).isRequired,
  data: _propTypes.default.arrayOf(_propTypes.default.object),
  disableSearch: _propTypes.default.bool,
  children: _propTypes.default.node.isRequired,
  sortOptions: optionType,
  filterOptions: optionType,
  groupBy: optionType,
  renderOther: _propTypes.default.func
};
var _default = Repeater;
exports.default = _default;