"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _core = require("@material-ui/core");
var _FilterList = _interopRequireDefault(require("@material-ui/icons/FilterList"));
var _SortByAlpha = _interopRequireDefault(require("@material-ui/icons/SortByAlpha"));
var _SelectForm = _interopRequireDefault(require("../SelectForm"));
var _Search = _interopRequireDefault(require("../Search"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const useStyle = (0, _core.makeStyles)(() => ({
  root: {
    '& button:disabled': {
      display: 'none'
    }
  }
}));
const RepeaterOptions = ({
  filterOptions,
  sortOptions,
  state,
  dispatch,
  disableSearch,
  children
}) => {
  const cls = useStyle();
  const handleChange = label => e => dispatch({
    type: label,
    payload: e.target.value
  });
  const handleInput = val => dispatch({
    type: 'input',
    payload: val
  });
  const {
    sortBy,
    filterBy
  } = state;
  return /*#__PURE__*/_react.default.createElement(_core.Box, {
    display: "flex",
    alignItems: "center",
    justifyContent: "flex-start",
    className: cls.root
  }, !disableSearch && /*#__PURE__*/_react.default.createElement(_core.Hidden, {
    smDown: true
  }, /*#__PURE__*/_react.default.createElement(_core.Box, {
    maxWidth: "100%",
    width: 320,
    mr: 1
  }, /*#__PURE__*/_react.default.createElement(_Search.default, {
    handleInput: handleInput
  }))), /*#__PURE__*/_react.default.createElement(_SelectForm.default, {
    handleChange: handleChange('filterBy'),
    icon: /*#__PURE__*/_react.default.createElement(_FilterList.default, null),
    label: "filterBy",
    options: filterOptions,
    value: filterBy
  }), /*#__PURE__*/_react.default.createElement(_SelectForm.default, {
    handleChange: handleChange('sortBy'),
    icon: /*#__PURE__*/_react.default.createElement(_SortByAlpha.default, null),
    label: "sortBy",
    options: sortOptions,
    value: sortBy
  }), children);
};
var _default = RepeaterOptions;
exports.default = _default;