"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.gt = exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Pagination = _interopRequireDefault(require("@material-ui/lab/Pagination"));
var _core = require("@material-ui/core");
var _NavigateNext = _interopRequireDefault(require("@material-ui/icons/NavigateNext"));
var _NavigateBefore = _interopRequireDefault(require("@material-ui/icons/NavigateBefore"));
var _lodash = require("lodash");
var _q3UiLocale = require("q3-ui-locale");
var _q3UiExports = require("q3-ui-exports");
var _q3UiHelpers = require("q3-ui-helpers");
var _List = _interopRequireDefault(require("../List"));
var _withMapRepeater = _interopRequireDefault(require("../withMapRepeater"));
var _helpers = require("../../helpers");
var _usePagination = _interopRequireDefault(require("../../usePagination"));
var _RepeaterCollapse = _interopRequireDefault(require("../RepeaterCollapse"));
var _RepeaterTableContext = _interopRequireDefault(require("../RepeaterTableContext/RepeaterTableContext"));
var _useStyle = _interopRequireDefault(require("../useStyle"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const gt = (v, num = 0) => v > num;
exports.gt = gt;
const RepeaterTable = ({
  data,
  children,
  disableMultiselect,
  renderNestedTableRow,
  perPage,
  groupName,
  ...rest
}) => {
  const {
    totalPage,
    total,
    onChange,
    list,
    page
  } = (0, _usePagination.default)(perPage, data);
  const cls = (0, _useStyle.default)();
  const {
    t
  } = (0, _q3UiLocale.useTranslation)('labels');
  const tableState = _react.default.useMemo(() => ({
    data: list
  }), [list]);
  const PaginationHeader = _react.default.useMemo(() => gt(totalPage, 1) ? /*#__PURE__*/_react.default.createElement(_core.Grid, {
    container: true
  }, /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true
  }, /*#__PURE__*/_react.default.createElement(_core.IconButton, {
    disabled: page === 1,
    onClick: () => onChange({}, page - 1)
  }, /*#__PURE__*/_react.default.createElement(_NavigateBefore.default, null))), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true
  }, /*#__PURE__*/_react.default.createElement(_core.IconButton, {
    disabled: page === totalPage,
    onClick: () => onChange({}, page + 1)
  }, /*#__PURE__*/_react.default.createElement(_NavigateNext.default, null)))) : null, [page, totalPage]);
  const PaginationFooter = _react.default.useMemo(() => gt(totalPage, 1) && /*#__PURE__*/_react.default.createElement(_core.Box, {
    display: "flex",
    justifyContent: "center",
    pb: 1
  }, /*#__PURE__*/_react.default.createElement(_Pagination.default, {
    page: page,
    count: totalPage,
    onChange: onChange,
    size: "small"
  })), [page, totalPage]);
  const TableElement = _react.default.useMemo(() => /*#__PURE__*/_react.default.createElement(_RepeaterTableContext.default.Provider, {
    value: tableState
  }, /*#__PURE__*/_react.default.createElement(_core.Table, {
    className: cls.table
  }, /*#__PURE__*/_react.default.createElement(_core.TableHead, null, /*#__PURE__*/_react.default.createElement(_core.TableRow, {
    className: cls.tableHeader
  }, /*#__PURE__*/_react.default.createElement(_core.TableCell, {
    component: "th"
  }, !disableMultiselect && /*#__PURE__*/_react.default.createElement("span", {
    style: {
      marginLeft: '-5px',
      paddingRight: '6px',
      position: 'relative'
    }
  }, /*#__PURE__*/_react.default.createElement(_q3UiExports.SelectAll, {
    ids: (0, _lodash.map)(list, 'id')
  })), t((rest === null || rest === void 0 ? void 0 : rest.th) || 'identifier')), (0, _lodash.map)((0, _lodash.get)(rest, 'cardProps.attributes', []), attr => /*#__PURE__*/_react.default.createElement(_core.TableCell, {
    key: attr,
    component: "th"
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: cls.tableHeaderSpan,
    title: t(attr)
  }, t(attr)))), /*#__PURE__*/_react.default.createElement(_core.TableCell, null))), /*#__PURE__*/_react.default.createElement(_List.default, _extends({}, rest, {
    renderNestedTableRow: renderNestedTableRow
  }), children))), [_q3UiHelpers.object.toJSON({
    disableMultiselect,
    list,
    rest
  })]);
  return gt(total, 0) && /*#__PURE__*/_react.default.createElement(_RepeaterCollapse.default, {
    label: groupName,
    toggles: PaginationHeader
  }, /*#__PURE__*/_react.default.createElement(_core.Box, {
    pb: 1
  }, groupName && /*#__PURE__*/_react.default.createElement(_core.Box, {
    className: cls.divide
  }), TableElement), PaginationFooter);
};
RepeaterTable.propTypes = {
  children: _propTypes.default.node,
  data: _propTypes.default.arrayOf(_propTypes.default.object),
  disableMultiselect: _propTypes.default.bool,
  groupName: _propTypes.default.string,
  perPage: _propTypes.default.number,
  renderNestedTableRow: _propTypes.default.func,
  ..._helpers.override.propTypes
};
RepeaterTable.defaultProps = {
  children: null,
  disableMultiselect: false,
  data: [],
  groupName: undefined,
  perPage: 15,
  renderNestedTableRow: null,
  ..._helpers.override.defaultProps
};
var _default = (0, _withMapRepeater.default)( /*#__PURE__*/_react.default.memo(RepeaterTable));
exports.default = _default;