"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.SearchContext = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _TextField = _interopRequireDefault(require("@material-ui/core/TextField"));
var _q3UiLocale = require("q3-ui-locale");
var _hooks = require("q3-ui-helpers/lib/hooks");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const SearchContext = /*#__PURE__*/_react.default.createContext();
exports.SearchContext = SearchContext;
const SearchBar = ({
  handleInput,
  ...rest
}) => {
  const [state, setState] = _react.default.useState('');
  const {
    t
  } = (0, _q3UiLocale.useTranslation)('labels');
  const shouldRun = (0, _hooks.useInputDebounce)(state);
  const handleChange = e => setState(e.target.value);
  _react.default.useEffect(() => {
    handleInput(state);
  }, [shouldRun]);
  return /*#__PURE__*/_react.default.createElement(_TextField.default, _extends({
    fullWidth: true,
    name: "search",
    onChange: handleChange,
    type: "search",
    value: state,
    autoComplete: "off",
    label: t('search'),
    variant: "outlined",
    size: "small"
  }, rest));
};
SearchBar.propTypes = {
  handleInput: _propTypes.default.func.isRequired
};
var _default = SearchBar;
exports.default = _default;