"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _q3UiLocale = require("q3-ui-locale");
var _core = require("@material-ui/core");
var _lodash = require("lodash");
var _usefulState = require("useful-state");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const SortForm = ({
  options,
  label,
  value,
  handleChange,
  icon
}) => {
  const {
    t
  } = (0, _q3UiLocale.useTranslation)('labels');
  const {
    open,
    anchorEl,
    close,
    isOpen
  } = (0, _usefulState.useOpen)();
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_core.Tooltip, {
    arrow: true,
    title: t((0, _lodash.get)(options, `${value}.label`, label))
  }, /*#__PURE__*/_react.default.createElement("span", null, /*#__PURE__*/_react.default.createElement(_core.IconButton, {
    color: "inherit",
    disabled: !(0, _lodash.size)(options),
    onClick: open
  }, icon))), /*#__PURE__*/_react.default.createElement(_core.Menu, {
    anchorEl: anchorEl,
    dense: true,
    onClose: close,
    open: isOpen
  }, (0, _lodash.map)(options, ({
    label: key
  }, i) => /*#__PURE__*/_react.default.createElement(_core.MenuItem, {
    key: key,
    onClick: () => {
      handleChange({
        target: {
          value: i
        }
      });
      close();
    },
    style: {
      margin: 0
    }
  }, t(key)))));
};
SortForm.propTypes = {
  options: _propTypes.default.arrayOf(_propTypes.default.shape({
    label: _propTypes.default.string.isRequired,
    fn: _propTypes.default.func
  })).isRequired,
  handleChange: _propTypes.default.func.isRequired,
  label: _propTypes.default.string.isRequired,
  value: _propTypes.default.number.isRequired,
  icon: _propTypes.default.element.isRequired
};
var _default = SortForm;
exports.default = _default;