"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.findIndexById = exports.findByIndex = exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _lodash = require("lodash");
var _RepeaterTableContext = _interopRequireDefault(require("../RepeaterTableContext"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const findIndexById = (a, id) => Array.isArray(a) && id ? a.findIndex(item => String(item.id) === String(id)) : -1;
exports.findIndexById = findIndexById;
const findByIndex = (a, index) => {
  try {
    const out = a[index];
    if (!out) throw new Error('ID does not exists in this array');
    return out;
  } catch (e) {
    return null;
  }
};
exports.findByIndex = findByIndex;
const useNextPrev = id => {
  const {
    data: state
  } = _react.default.useContext(_RepeaterTableContext.default);
  const count = (0, _lodash.size)(state);
  const index = findIndexById(state, id);
  const data = findByIndex(state, index);
  const getIdOf = v => {
    var _findByIndex;
    return (_findByIndex = findByIndex(state, v)) === null || _findByIndex === void 0 ? void 0 : _findByIndex.id;
  };
  return {
    data,
    next() {
      const newIndex = index + 1;
      return getIdOf(newIndex > count - 1 ? 0 : newIndex);
    },
    prev() {
      const newIndex = index - 1;
      return getIdOf(newIndex < 0 ? count - 1 : newIndex);
    }
  };
};
var _default = useNextPrev;
exports.default = _default;