"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _q3UiPermissions = require("q3-ui-permissions");
var _default = ({
  collectionName,
  name,
  ...rest
}) => {
  const auth = (0, _q3UiPermissions.useAuth)(collectionName);
  return Object.entries({
    disable: ['canSeeSub'],
    disableCreate: ['canCreateSub'],
    disableEditor: ['canEditSub'],
    disableMultiselect: ['canDeleteSub', 'canEditSub'],
    disableRemove: ['canDeleteSub']
  }).reduce((acc, [key, value]) => {
    acc[key] = rest[key] || value.every(method => !auth[method](name));
    return acc;
  }, {
    auth,
    collectionName
  });
};
exports.default = _default;