"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _lodash = require("lodash");
var _q3UiHelpers = require("q3-ui-helpers");
var _core = require("@material-ui/core");
var _q3UiLocale = require("q3-ui-locale");
var _useRepeaterDecorator = _interopRequireDefault(require("../../useRepeaterDecorator"));
var _Editable = _interopRequireDefault(require("../Editable"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const withEditableTypography = ({
  data,
  ...sharedProps
}) => {
  const EditableTypographyFormatter = ({
    name,
    editable,
    ...rest
  }) => {
    const {
      t
    } = (0, _q3UiLocale.useTranslation)('labels');
    const repeater = (0, _useRepeaterDecorator.default)(name, editable);
    const defaultPlaceholder = '--';
    if (!repeater) return defaultPlaceholder;
    if (_q3UiHelpers.object.isFn(name)) return /*#__PURE__*/_react.default.createElement(_core.Typography, rest, name(data));
    const {
      edit,
      isEditable
    } = repeater;
    const {
      renderer
    } = editable;
    const removeFormatters = args => (0, _lodash.omit)(args, ['toDate', 'toPrice', 'trans', 'toTruthy', 'collectionName']);
    const formatText = value => {
      let formatted = value;
      const {
        type,
        toDate,
        toSimpleDate,
        toYearMonthDay,
        toPrice,
        toTruthy,
        trans
      } = editable;
      if (type === 'number') formatted = _q3UiHelpers.string.toNumber(value, defaultPlaceholder);
      if (type === 'checkbox' || toTruthy) formatted = _q3UiHelpers.string.toTruthy(value, t);
      if (type === 'date' || toDate) {
        if (toSimpleDate) formatted = _q3UiHelpers.string.toSimpleDate(value, defaultPlaceholder);else if (toYearMonthDay) formatted = _q3UiHelpers.string.toYearMonthDay(value, defaultPlaceholder);else formatted = _q3UiHelpers.string.toDate(value, defaultPlaceholder);
      }
      if (toPrice) formatted = _q3UiHelpers.string.toPrice(value);
      if (trans) formatted = t(value);
      if (!formatted) formatted = defaultPlaceholder;
      return formatted;
    };
    const onSubmit = (...params) => edit(data.id)(...params);
    const text = formatText((0, _lodash.get)(data, name), editable, t);
    if ((0, _lodash.isFunction)(renderer)) return renderer(data, onSubmit);
    return isEditable ? /*#__PURE__*/_react.default.createElement(_Editable.default, {
      ...removeFormatters((0, _lodash.merge)({}, sharedProps, rest, editable)),
      initialValues: data,
      name,
      onSubmit,
      text
    }) : text;
  };
  EditableTypographyFormatter.defaultProps = {
    editable: {}
  };
  EditableTypographyFormatter.propTypes = {
    name: _propTypes.default.string.isRequired,
    editable: _propTypes.default.shape({
      renderer: _propTypes.default.func,
      type: _propTypes.default.string,
      toDate: _propTypes.default.bool,
      toPrice: _propTypes.default.bool,
      toTruthy: _propTypes.default.bool,
      trans: _propTypes.default.bool
    })
  };
  return EditableTypographyFormatter;
};
var _default = withEditableTypography;
exports.default = _default;