"use strict";

var _withEditableTypography = _interopRequireDefault(require("./withEditableTypography"));
var _useRepeaterDecorator = _interopRequireDefault(require("../../useRepeaterDecorator"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
jest.mock('../../useRepeaterDecorator');
describe('withEditableTypography', () => {
  it('should return dashed lines without decorators', () => {
    _useRepeaterDecorator.default.mockReturnValue(null);
    expect((0, _withEditableTypography.default)({
      data: null
    })({
      name: 'foo'
    })).toMatch('--');
  });
  it('should return Typography if given a name resolver', () => {
    const name = jest.fn();
    _useRepeaterDecorator.default.mockReturnValue({});
    const el = (0, _withEditableTypography.default)({
      data: null
    })({
      name
    });
    expect(name).toHaveBeenCalled();
    expect(el.type.displayName).toMatch('(Typography)');
  });
  it('should return EditableTypography', () => {
    _useRepeaterDecorator.default.mockReturnValue({
      edit: jest.fn(),
      isEditable: true,
      prefix: 'foo'
    });
    const el = (0, _withEditableTypography.default)({
      data: {
        foo: 'bar'
      }
    })({
      name: 'foo',
      editable: {
        type: 'text'
      }
    });
    expect(el.props).toMatchObject({
      onSubmit: expect.any(Function),
      initialValues: {
        foo: 'bar'
      },
      name: 'foo'
    });
  });
});