"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _q3UiLocale = require("q3-ui-locale");
var _lodash = require("lodash");
var _q3UiHelpers = require("q3-ui-helpers");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const withMapRepeater = Component => {
  const Inner = ({
    children,
    data,
    ...rest
  }) => {
    const {
      t
    } = (0, _q3UiLocale.useTranslation)();
    const renderRepeater = () => /*#__PURE__*/_react.default.createElement(Component, _extends({
      data: data
    }, rest), children);
    const mapRepeater = () => Object.entries(data).map(([key, xs]) => (0, _lodash.size)(xs) !== 0 && /*#__PURE__*/_react.default.createElement(Component, _extends({
      key: key,
      data: xs,
      ids: xs.map(item => item.id),
      groupName: t(key)
    }, rest), children));
    return _react.default.useMemo(() => Array.isArray(data) ? renderRepeater() : mapRepeater(), [_q3UiHelpers.object.toJSON(data), _q3UiHelpers.object.toJSON(rest)]);
  };
  Inner.propTypes = {
    data: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.array]).isRequired,
    children: _propTypes.default.node.isRequired
  };
  return Inner;
};
var _default = withMapRepeater;
exports.default = _default;