"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _helpers = require("../../helpers");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const withReducer = (Component, [state, dispatch]) => {
  const Inner = ({
    options,
    label,
    data
  }) => {
    const handleChange = e => dispatch({
      type: label,
      payload: e.target.value
    });
    return (0, _helpers.haveLength)(options, data) && /*#__PURE__*/_react.default.createElement(Component, {
      options: options,
      label: label,
      handleChange: handleChange,
      value: state[label]
    });
  };
  Inner.defaultProps = {
    options: []
  };
  Inner.propTypes = {
    options: _propTypes.default.arrayOf(_propTypes.default.shape({
      label: _propTypes.default.string.isRequired,
      fn: _propTypes.default.func
    })),
    label: _propTypes.default.string.isRequired,
    data: _propTypes.default.arrayOf(_propTypes.default.object).isRequired
  };
  return Inner;
};
var _default = withReducer;
exports.default = _default;