"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.RepeaterDecorator = void 0;
var _react = _interopRequireDefault(require("react"));
var _lodash = require("lodash");
var _q3UiHelpers = require("q3-ui-helpers");
var _state = _interopRequireDefault(require("./components/state"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const {
  hasKeys
} = _q3UiHelpers.object;
const RepeaterDecorator = (repeater, options = {}) => ({
  get prefix() {
    return (0, _lodash.hasIn)(repeater, 'name') ? `${repeater.name}.${options.name}` : options.name;
  },
  get isEditable() {
    return typeof repeater.edit === 'function' && (0, _lodash.invoke)(repeater, 'auth.canEditSub', this.prefix) && hasKeys(options.editable);
  }
});
exports.RepeaterDecorator = RepeaterDecorator;
var _default = (name, editable) => {
  const repeater = _react.default.useContext(_state.default);
  const decorators = RepeaterDecorator(repeater, {
    editable,
    name
  });
  return (0, _lodash.isFunction)(name) || (0, _lodash.invoke)(repeater, 'auth.canSeeSub', decorators.prefix) ? {
    ...repeater,
    ...decorators
  } : null;
};
exports.default = _default;